//modified by Jing Yang after 7/6/2001
#ifndef XMDVTOOL_H
#define XMDVTOOL_H

#include "okcdata.H"
#include "CFlatDisplayInformation.H"
#include "CHierDisplayInformation.H"
#include "CDimReductionDisplayInformation.H"
#include "CScreenDistortion.H"
#include "macros.H"
#include "CSunburstDimClusterTree.H"
#include "CDimReducer.H"
#include "SessionMgmt/HistMgmt.h"  //YK

/*
#define M_PI		3.14159265358979323846
*/

/* SID */
extern int Prefetcher;
extern int BrushSemantic;		/* ALL = 0, ANY = 1, ... */
extern int Prefetch_Strategy;		/* */

extern bool backend;

extern struct okcdata *dataset;

extern int DSIZE;

enum interface_item {
    BG,
    TEXT,
    DATA,
    HIGHLIGHT1,
    HIGHLIGHT2,
    HIGHLIGHT3,
    HIGHLIGHT4,
    OVERLAP,
    PAINT,
    GRID1,
    GRID2,
    GRID3,
    GRID4,
    STAT1,
    STAT2,
    BRUSH1,
    BRUSH2,
    BRUSH3,
    BRUSH4,
    SBB,
    NUM_INTERFACE_ITEM
};
extern unsigned long interface_color[NUM_INTERFACE_ITEM];
extern CFlatDisplayInformation* flat_info;
extern CHierDisplayInformation* hier_info;
extern CDimReductionDisplayInformation* dim_reduction_info;
extern CScreenDistortion* screen_distortion;
extern CSunburstDimClusterTree* dtree;
extern CDimReducer* dim_reducer;
extern HistMgmt* histMgmt;	//YK
//new change
extern char* default_file_name;

extern void appCanvasMousePan(struct grCanvas *);
extern void appRefreshAllCanvas(struct Tcl_Interp *interp, struct grCanvas *except_this=0);
extern void appSetupBrushStatistics(struct Tcl_Interp *interp);
extern void appRefreshGlyphPlacementDialog(struct Tcl_Interp *interp);
extern void appUpdateClusterRadiusSliders(struct Tcl_Interp *interp);
extern void appUpdateTreeBrushEntries(struct Tcl_Interp *interp);
extern void appCanvasBrushHasChanged(Tcl_Interp *interp);
//extern void appShowCaption(Tcl_Interp *interp, const char *str);
extern void appShowCanvasMessage(Tcl_Interp *interp, const char *str, const char *canvasName);
extern void appShowSunburstCaption(Tcl_Interp *interp, const char *str);
//it is used by brush tools. 
extern void appBrushBoundaryCaption(struct grCanvas *, int axis);
extern void appCanvasInputKeyPress(struct grCanvas *canvas, int key);
extern void appCanvasInputKeyRelease(struct grCanvas *canvas, int key);

//YS
enum ACTIONS {	//an A preceding a constant will mean it represents an "Action"
    A_EMPTY,	//to account for the array starting at 0
	A_HIER_L_B_H,
    A_HIER_R_B_H,
    A_HIER_I_C,
    A_HIER_O_C,
	A_EXIT,		//because input simulation uses 5 for exiting system
	A_HIER_M_B
};
//YE

#endif
